//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"
//---
#include <stdlib.mqh>
#define pi 3.14159265358979323846
//---
#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import
//---
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_maximum 1
#property indicator_minimum 0
#property indicator_color1 Red
#property indicator_color2 Blue
//---- buffers
double SpecktrBuffer[];
double LineBuffer[];
//---
extern int n=8;//    -  
extern double f=1.0;//   
extern double ff=0;//   

datetime prev_date;
static datetime prevtime=0;   


extern int    N      =64; // Number of last bars. Must be the power of 2. 0: all data.
//extern int    htrun  =5;   // Number of the last wavelets to truncate.
// Damping factor. Higher Q gives more ripple. Q=1 gives sinc function. 
extern double Q      =0.5;
extern int i_Sampling = 4; 
//Global variables
int pwrMax; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_HISTOGRAM);
SetIndexBuffer(0,SpecktrBuffer);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,LineBuffer);
//SetIndexEmptyValue(1,0);
ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
  if (!isNewBar()) return(0);

   int tnn1=MathPow(2,n);//   -      
   double aa[];
   int N=ArrayResize(aa,tnn1);
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   //ArrayResize(aa,tnn1+1); // -
   //---
   //    
   double sig;
   double pr;
   for(int i=0; i<=N-1; i++)
   {
      //pr=iCustom(NULL, 0, "regress_continue",1,2,N,0,0,i);
      sig=Close[i] - Close[i+1];
      aa[i]=sig;
   }
   
   realfastfouriertransform(aa, tnn1, false); 
   InSigNormalize(aa); //  
   

   for( i=0; i<=N-1; i++)
   {
      SpecktrBuffer[i]=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      LineBuffer[i] = 0.1;  
   }

   //---- Wavelet transformation
   int nn = N/2-1;
   
     ArrayInitialize(LineBuffer, EMPTY_VALUE);
   double Fit[], Dif[];
   ArrayResize(Fit, nn+1);
   ArrayResize(Dif, nn+1);
   for(i = 0; i <= nn; i++)
     {
       Fit[i] = (SpecktrBuffer[nn] - SpecktrBuffer[0])*i / nn + SpecktrBuffer[0];
       Dif[i] = SpecktrBuffer[i] - Fit[i];
       LineBuffer[i] = Fit[i];      
     }
   int ss = 2*nn; // sampling step
   for(int p = 1; p <= i_Sampling; p++)
     {
       ss = ss / 2;
       for(i = 0; i <= nn; i++)
         {
           Fit[i] = 0.0;
           for(int j = 1; j <= (nn) / ss; j++)
               Fit[i] += Dif[j*ss - ss / 2]*wave(2*j - 1 - 2.0*i / ss, Q);
         }
         
       for(i = 0; i <= nn; i++)
         {
               Dif[i] -= Fit[i];               
               LineBuffer[i] += Fit[i]; //original
         }         
     }
   

      double yy = 0;
      double nc = nn+1;
      double inc = 1/nc;     
      
     for(i = 0; i <= nn; i++)
     {
         double RR = SpecktrBuffer[i]*2.5;
         //double RR = LineBuffer[i]*2.5;
         
         yy+=inc;   
         string name = "object"+ObjectsTotal();
         ObjectCreate(name, OBJ_ARROW, 1, Time[0], yy);
         ObjectSet(name, OBJPROP_ARROWCODE, 110);
         //ObjectSet(name, OBJPROP_COLOR, ((yy*16777215)+(yy*65536)+(yy*256))); //gradient
         ObjectSet(name, OBJPROP_COLOR, ((00*16777215)+(00*65536)+(RR*256))); //gradient
         ObjectSet(name, OBJPROP_WIDTH, 1);
         //color
     }
     
   return(0);
  }
  
//+------------------------------------------------------------------+
//sinc function------------------------------------------------------+
double wave(double x, double Q)
  {
   if(x == 0.0)
       return(1.0);
   else 
       return(MathSin(0.5*pi*x) / (0.5*pi*x) / (x*x + 1)*(Q*x*x + 1));
       //return(MathSin(pi*x) / (pi*x));
  }
//+------------------------------------------------------------------+
bool isNewBar()
{
   if(prevtime == Time[0])  return(false);
   prevtime = Time[0];      
   return(true);
   
}
//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}
//---------------------------------------------------------------------+